
package com.sreal.visiproxjr;

public class Circuit
{
	private int number_of_threads = 2;
	private java.net.Socket socket_to_client;
	private java.net.Socket socket_to_server;
	private java.io.OutputStream log;
	private com.sreal.visiproxjr.PumpThread client_to_server_thread;
	private com.sreal.visiproxjr.PumpThread server_to_client_thread;

	public Circuit(java.net.Socket socket_to_client, java.lang.String server_hostname, int server_port, java.lang.String log_filename) throws java.io.IOException, java.net.UnknownHostException, java.io.FileNotFoundException
	{
		this.socket_to_client = socket_to_client;
		this.socket_to_server = new java.net.Socket(server_hostname, server_port);
		this.log = new java.io.FileOutputStream(log_filename);
		this.client_to_server_thread = new com.sreal.visiproxjr.PumpThread(this.socket_to_client.getInputStream(), this.socket_to_server.getOutputStream(), this);
		this.server_to_client_thread = new com.sreal.visiproxjr.PumpThread(this.socket_to_server.getInputStream(), this.socket_to_client.getOutputStream(), this);
		this.client_to_server_thread.start();
		this.server_to_client_thread.start();
	}

	public synchronized void log(byte[] buffer, int offset, int amount) throws java.io.IOException
	{
		this.log.write(buffer, offset, amount);
		this.log.flush();
	}

	public synchronized void close() throws java.io.IOException
	{
		if (--number_of_threads == 0)
		{
			this.socket_to_client.close();
			this.socket_to_server.close();
			this.log.close();
		}
	}
}

